// ------------------------------------------------------------
// ascii art
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
float4 MaterialAmbientColor;
float4 MaterialDiffuseColor;

float3 LightDir = normalize(float3(1.0f, 1.0f, -1.0f));
float4 LightAmbient = { 1.0f, 1.0f, 1.0f, 1.0f };    // ambient
float4 LightDiffuse = { 1.0f, 1.0f, 1.0f, 1.0f };    // diffuse


//float4x4 mWorld;
float4x4 mWorldIT;
//float4x4 mWorldView;
float4x4 mWorldViewProjection;

float INV_TEXSIZE;

texture SrcMap;
sampler SrcSamp = sampler_state
{
    Texture = <SrcMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture PointMap;
sampler PointSamp = sampler_state
{
    Texture = <PointMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture WaveletTexture;
sampler WaveletSamp = sampler_state
{
    Texture = <WaveletTexture>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};

texture SrcMap0;
sampler SrcSamp0 = sampler_state
{
    Texture = <SrcMap0>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture SrcMap1;
sampler SrcSamp1 = sampler_state
{
    Texture = <SrcMap1>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture SrcMap2;
sampler SrcSamp2 = sampler_state
{
    Texture = <SrcMap2>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture SrcMap3;
sampler SrcSamp3 = sampler_state
{
    Texture = <SrcMap3>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

texture IndexMap;
sampler IndexSamp = sampler_state
{
    Texture = <IndexMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};




// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};


// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS_pass1(VS_OUTPUT In) : COLOR
{   
	float3 Color = tex2D( SrcSamp, In.Tex ).xyz;
	const float3 RGB2Y = {0.299, 0.587, 0.114};
	float Y;
	
	Y = dot(Color, RGB2Y);
	
    return Y;
}
// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_1_1 PS_pass1();
        
		Sampler[0] = (SrcSamp);
    }
}




//-----------------------------------------------------------------------------
// Vertex shader output structure
//-----------------------------------------------------------------------------
struct SmallFragment
{
    float4 Position  : POSITION;
    float2 TextureUV0 : TEXCOORD0;
    float2 TextureUV1 : TEXCOORD1;
    float2 TextureUV2 : TEXCOORD2;
    float2 TextureUV3 : TEXCOORD3;
    float2 TextureUV4 : TEXCOORD4;
    float2 TextureUV5 : TEXCOORD5;
    float2 TextureUV6 : TEXCOORD6;
    float2 TextureUV7 : TEXCOORD7;
};


//-----------------------------------------------------------------------------
// Name: Reduct VS
// Type: Vertex shader                                      
// Desc: 
//-----------------------------------------------------------------------------
SmallFragment SmallVS( float3 vPos : POSITION, 
                       float2 vTexCoord : TEXCOORD )
{
    SmallFragment Output;
  
    Output.Position.x =  vPos.x;
    Output.Position.y = -vPos.y;    
    Output.Position.z = 0.5f;
    Output.Position.w = 1;
    
    Output.TextureUV0 = vTexCoord + float2(1.0f, 1.0f) * INV_TEXSIZE;
    Output.TextureUV1 = vTexCoord + float2(1.0f, 3.0f) * INV_TEXSIZE;
    Output.TextureUV2 = vTexCoord + float2(1.0f, 5.0f) * INV_TEXSIZE;
    Output.TextureUV3 = vTexCoord + float2(1.0f, 7.0f) * INV_TEXSIZE;
    Output.TextureUV4 = vTexCoord + float2(3.0f, 1.0f) * INV_TEXSIZE;
    Output.TextureUV5 = vTexCoord + float2(3.0f, 3.0f) * INV_TEXSIZE;
    Output.TextureUV6 = vTexCoord + float2(3.0f, 5.0f) * INV_TEXSIZE;
    Output.TextureUV7 = vTexCoord + float2(3.0f, 7.0f) * INV_TEXSIZE;
    
    return Output;    
}


//-----------------------------------------------------------------------------
// Name: Reduct PixelShader
// Type: Pixel shader
// Desc: This shader simply outputs the pixel's color 
//-----------------------------------------------------------------------------
float4 SmallPS( SmallFragment In ) : COLOR
{ 
    float2 ofset = float2(4.0f, 0.0f) * INV_TEXSIZE;
    
    return (1.0f/16.0f)*(
		  tex2D( SrcSamp, In.TextureUV0) + tex2D( SrcSamp, In.TextureUV0 + ofset)
		+ tex2D( SrcSamp, In.TextureUV1) + tex2D( SrcSamp, In.TextureUV1 + ofset)
		+ tex2D( SrcSamp, In.TextureUV2) + tex2D( SrcSamp, In.TextureUV2 + ofset)
		+ tex2D( SrcSamp, In.TextureUV3) + tex2D( SrcSamp, In.TextureUV3 + ofset)
		+ tex2D( SrcSamp, In.TextureUV4) + tex2D( SrcSamp, In.TextureUV4 + ofset)
		+ tex2D( SrcSamp, In.TextureUV5) + tex2D( SrcSamp, In.TextureUV5 + ofset)
		+ tex2D( SrcSamp, In.TextureUV6) + tex2D( SrcSamp, In.TextureUV6 + ofset)
		+ tex2D( SrcSamp, In.TextureUV7) + tex2D( SrcSamp, In.TextureUV7 + ofset)
    );
}


//-----------------------------------------------------------------------------
// Name: Simple Shader
// Type: Technique                                     
// Desc: .
//-----------------------------------------------------------------------------
technique SmallTech
{
    pass P0
    {        
        VertexShader = compile vs_1_1 SmallVS();
        PixelShader  = compile ps_2_0 SmallPS();
        
        CULLMODE =NONE;
    }
}


//-----------------------------------------------------------------------------
// Name: Wavelet VS
// Type: Vertex shader                                      
// Desc: 
//-----------------------------------------------------------------------------
SmallFragment WaveletVS( float3 vPos : POSITION, 
                       float2 vTexCoord : TEXCOORD )
{
    SmallFragment Output=(SmallFragment)0;
  
    Output.Position.x =  vPos.x;
    Output.Position.y = -vPos.y;
    Output.Position.z = 0.5f;
    Output.Position.w = 1;
    
    Output.TextureUV0 = vTexCoord + 0.5 * INV_TEXSIZE;
    
    return Output;    
}

//-----------------------------------------------------------------------------
// Name: WaveletPS
// Type: Pixel shader
// Desc: 
//-----------------------------------------------------------------------------
float4 WaveletPS( SmallFragment In ) : COLOR
{
    return 0.5f + 2.0 * (tex2D(   PointSamp,    In.TextureUV0)-0.5)
					  * (tex2D( WaveletSamp, 16*In.TextureUV0)-0.5);
}


//-----------------------------------------------------------------------------
// Name: 64 box sampling
// Type: Vertex shader                                      
// Desc: 
//-----------------------------------------------------------------------------
SmallFragment Small4VS( float3 vPos : POSITION, 
                       float2 vTexCoord : TEXCOORD )
{
    SmallFragment Output;
  
    Output.Position.x =  vPos.x;
    Output.Position.y = -vPos.y;
    Output.Position.z = 0.5f;
    Output.Position.w = 1;
    
    Output.TextureUV0 = vTexCoord + float2(0.5f, 0.5f) * INV_TEXSIZE;
    Output.TextureUV1 = vTexCoord + float2(0.5f, 1.5f) * INV_TEXSIZE;
    Output.TextureUV2 = vTexCoord + float2(1.5f, 0.5f) * INV_TEXSIZE;
    Output.TextureUV3 = vTexCoord + float2(1.5f, 1.5f) * INV_TEXSIZE;
    Output.TextureUV4 = vTexCoord + float2(2.5f, 0.5f) * INV_TEXSIZE;
    Output.TextureUV5 = vTexCoord + float2(2.5f, 1.5f) * INV_TEXSIZE;
    Output.TextureUV6 = vTexCoord + float2(3.5f, 0.5f) * INV_TEXSIZE;
    Output.TextureUV7 = vTexCoord + float2(3.5f, 1.5f) * INV_TEXSIZE;
    
    return Output;    
}


//-----------------------------------------------------------------------------
// Name: 64 box sampling
// Type: Pixel shader
// Desc: 
//-----------------------------------------------------------------------------
float4 Small4PS( SmallFragment In ) : COLOR
{ 
    float2 ofset = float2(0.0f, 2.0f) * INV_TEXSIZE;
    
    return (1.0f/16.0f)*(
		  tex2D( SrcSamp, In.TextureUV0) + tex2D( SrcSamp, In.TextureUV0 + ofset)
		+ tex2D( SrcSamp, In.TextureUV1) + tex2D( SrcSamp, In.TextureUV1 + ofset)
		+ tex2D( SrcSamp, In.TextureUV2) + tex2D( SrcSamp, In.TextureUV2 + ofset)
		+ tex2D( SrcSamp, In.TextureUV3) + tex2D( SrcSamp, In.TextureUV3 + ofset)
		+ tex2D( SrcSamp, In.TextureUV4) + tex2D( SrcSamp, In.TextureUV4 + ofset)
		+ tex2D( SrcSamp, In.TextureUV5) + tex2D( SrcSamp, In.TextureUV5 + ofset)
		+ tex2D( SrcSamp, In.TextureUV6) + tex2D( SrcSamp, In.TextureUV6 + ofset)
		+ tex2D( SrcSamp, In.TextureUV7) + tex2D( SrcSamp, In.TextureUV7 + ofset)
    );
}


//-----------------------------------------------------------------------------
// Name: 64 box sampling
// Type: Technique                                     
// Desc: .
//-----------------------------------------------------------------------------
technique SmallTech4
{
    pass P0
    {        
        VertexShader = compile vs_1_1 Small4VS();
        PixelShader  = compile ps_2_0 Small4PS();
        
        CULLMODE =NONE;
    }
}


//-----------------------------------------------------------------------------
// Name: Wavelet Shader
// Type: Technique                                     
// Desc: .
//-----------------------------------------------------------------------------
technique WaveletTech
{
    pass P0
    {        
        VertexShader = compile vs_1_1 WaveletVS();
        PixelShader  = compile ps_2_0 WaveletPS();
        
        CULLMODE =NONE;
    }
}





// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 DiffPS ( float2 TexCoord : TEXCOORD0 ) : COLOR
{
	float4 o;
	float4 co0 = tex2D( SrcSamp0, TexCoord );
	float4 co1 = tex2D( SrcSamp1, TexCoord );
	float4 co2 = tex2D( SrcSamp2, TexCoord );
	float4 co3 = tex2D( SrcSamp3, TexCoord );
	
	float4 target00 = tex2D( PointSamp, float2( 0.5/52.0 + INV_TEXSIZE, 0.5/4) );
	float4 target01 = tex2D( PointSamp, float2( 0.5/52.0 + INV_TEXSIZE, 1.5/4) );
	float4 target02 = tex2D( PointSamp, float2( 0.5/52.0 + INV_TEXSIZE, 2.5/4) );
	float4 target03 = tex2D( PointSamp, float2( 0.5/52.0 + INV_TEXSIZE, 3.5/4) );
	
	float4 c00 = co0 - target00;
	float4 c01 = co1 - target01;
	float4 c02 = co2 - target02;
	float4 c03 = co3 - target03;

	o = dot(c00,c00)		// d݂ςāAȂقʂ傫
		+ 2.0*( dot(c01,c01) + dot(c02,c02) + dot(c03,c03) );

    return o;
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique DiffTech
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_2_0 DiffPS();
    }
}




//-----------------------------------------------------------------------------
// Pixel shader output structure
//-----------------------------------------------------------------------------
struct CompareFragment
{
    float4 Value  : COLOR0;
    float4 Index  : COLOR1;
};

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
CompareFragment ComparePS ( float2 TexCoord : TEXCOORD0 )
{
	CompareFragment O;
	float value;
	float index;
	float4 c0 = tex2D( SrcSamp0, TexCoord );
	float4 c1 = tex2D( SrcSamp1, TexCoord );
	float4 c2 = tex2D( SrcSamp2, TexCoord );
	float4 c3 = tex2D( SrcSamp3, TexCoord );
	float4 i0 = float4( 0.0/52.0,  1.0/52.0,  2.0/52.0,  3.0/52.0);
	float4 i1 = float4( 4.0/52.0,  5.0/52.0,  6.0/52.0,  7.0/52.0);
	float4 i2 = float4( 8.0/52.0,  9.0/52.0, 10.0/52.0, 11.0/52.0);
	float4 i3 = float4(12.0/52.0, 13.0/52.0, 14.0/52.0, 15.0/52.0);
	
	i0 = ( c0 <= c1 ) ? i0 : i1;
	c0 = ( c0 <= c1 ) ? c0 : c1;
	
	i2 = ( c2 <= c3 ) ? i2 : i3;
	c2 = ( c2 <= c3 ) ? c2 : c3;
	
	i0 = ( c0 <= c2 ) ? i0 : i2;
	c0 = ( c0 <= c2 ) ? c0 : c2;
	
	index = i0.x;
	value = c0.x;
	
	if( c0.y <= value ) {index = i0.y; value = c0.y;}
	if( c0.z <= value ) {index = i0.z; value = c0.z;}
	if( c0.w <= value ) {index = i0.w; value = c0.w;}
	
	O.Value = value;
	O.Index = index + INV_TEXSIZE;
	
    return O;
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique CompareTech
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_2_0 ComparePS();
    }
}




// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 Compare2PS ( float2 TexCoord : TEXCOORD0 ) : COLOR0
{
	float value;
	float index;
	float4 c0 = tex2D(  SrcSamp0, TexCoord );
	float4 i0 = tex2D( IndexSamp, TexCoord );
	
	index = i0.x;
	value = c0.x;
	
	if( c0.y <= value ) {index = i0.y; value = c0.y;}
	if( c0.z <= value ) {index = i0.z; value = c0.z;}
	if( c0.w <= value ) {index = i0.w; value = c0.w;}
	
    return index;
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique Compare2Tech
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_2_0 Compare2PS();
    }
}




// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct FinalFragment
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 FinalPS ( float2 TexCoord : TEXCOORD0 ) : COLOR
{
	float idx = floor( 52 * tex2D( SrcSamp0, TexCoord ) );
	
	float2 texcoord;
	float2 t_mod = fmod( 16*TexCoord, 1 );
	texcoord.x = (1.0/52.0) * (idx + t_mod.x );
	texcoord.y = t_mod.y;
	
    return tex2D( SrcSamp, texcoord ) * tex2D( PointSamp, TexCoord );
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique FinalTech
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_2_0 FinalPS();
    }
}




//-----------------------------------------------------------------------------
// Vertex shader output structure
//-----------------------------------------------------------------------------
struct SimpleFragment
{
    float4 Position  : POSITION;
    float4 Diffuse   : COLOR0;
    float2 TextureUV : TEXCOORD0;
};


//-----------------------------------------------------------------------------
// Name: SimpleVS
// Type: Vertex shader                                      
// Desc: 
//-----------------------------------------------------------------------------
SimpleFragment SimpleVS( float4 vPos : POSITION, 
                             float3 vNormal : NORMAL,
                             float2 vTexCoord0 : TEXCOORD0 )
{
    SimpleFragment Output;
    float3 vWorldNormal;
  
    // tranform vertex position into screen space
    Output.Position = mul(vPos, mWorldViewProjection);
    
    // tranform vertex normal into world space
    vWorldNormal = mul(vNormal, (float3x3)mWorldIT);       
    vWorldNormal = normalize(vWorldNormal);
    
    // Compute simple lighting equation
    Output.Diffuse.rgb = MaterialDiffuseColor * LightDiffuse * max(0,dot(vWorldNormal, LightDir)) + 
                         MaterialAmbientColor * LightAmbient;
    Output.Diffuse.a = 0;
    
    // Just copy the texture coordinate through
    Output.TextureUV = vTexCoord0;
    
    return Output;    
}


//-----------------------------------------------------------------------------
// Name: SimplePixelShader
// Type: Pixel shader
// Desc: This shader simply outputs the pixel's color 
//-----------------------------------------------------------------------------
float4 SimplePS( SimpleFragment In ) : COLOR
{ 
    // Lookup mesh texture and modulate it with the diffuse color
    return tex2D( SrcSamp, In.TextureUV);// * In.Diffuse;
}


//-----------------------------------------------------------------------------
// Name: Simple Shader
// Type: Technique                                     
// Desc: .
//-----------------------------------------------------------------------------
technique SimpleTech
{
    pass P0
    {        
        VertexShader = compile vs_1_1 SimpleVS();
        PixelShader  = compile ps_2_0 SimplePS();
    }
}




